// myflash.h
//=======================================================================
#define UART_ID uart0

extern struct myswitch switch1;
extern struct myswitch switch2;
extern struct myswitch switch3;

extern void do_switch(unsigned char, struct myswitch *); 
extern unsigned char timer_flag;

void do_flash(void);
extern void do_clock(void);

// Messages (duplicate in clock.h)
struct messages
{
    unsigned char pos;        // position
    unsigned char numchars;   // number of characters
    unsigned char msg[];      // message
};

extern unsigned char nflag;
//=======================================================
extern char nstr[512];
extern char line[512];
unsigned char temp_buffer[256];
char start_date[20];

extern unsigned char uart_char;
extern unsigned char irq_flag, secs_flag, uart_flag;
extern unsigned int save_count, irq_count; 
extern unsigned char nflag;
unsigned int ts_number;

extern void LED_break(void);

void my_itoa(unsigned int, char *);
void my_itoa2(unsigned int, char *);
void line_fill_bin(unsigned char,char *, unsigned char, unsigned char);
void line_fill(unsigned char, char *, unsigned char, unsigned char);
void log_time(void);
void log2_time_uart(void);
//===============================================================
//Time-stamped log 32 bytes - duplicated in bme.h
struct log
{
   uint16_t ts_number;     // index number                   0,1
   
   uint8_t ts_date;       // ASCII time-stamped date        2
   uint8_t ts_day;        // ASCII time-stamped day         3
   uint8_t ts_month;      // ASCII time-stamped month       4
   uint8_t ts_year;       // ASCII time-stamped year        5

   uint8_t ts_hours;      // ASCII time-stamped hour        6
   uint8_t ts_minutes;    // ASCII time-stamped minutes     7
   uint8_t ts_seconds;    // ASCII time-stamped second      8

   int32_t Ftemperature;  //  Hes                           9, 10, 11, 12
   uint32_t Pressure;     //  Hex                           13, 14 15, 16  
   uint32_t Humidity;     //  Hex                           17, 18, 19, 20

   uint8_t data[10];      // just Hex data                  21 - 30
                      
   uint8_t flag;          // flag for non-blank             31
};

void make_entry(void);
struct log flash_entry;   // make the log entry to be used inRAM and Flash
uint8_t test_data_start;
void show_log(struct log *ptr);
//================================================================
// LCD Messages
const struct messages tx_msg1 = {0x81, 14, "Jed Margolin's"};
const struct messages tx_msg2 = {0xC2, 10,  "Flash Demo"};
const struct messages tx_msg3 = {0x83, 8,  "(C) 2024"};
const struct messages tx_msg4 = {0x82, 12, "Flash 7/4/24"};
//=================================================================
// From clock.c
#define SECS   0
#define MINS   1
#define HOURS  2
#define DAY    3
#define DATE   4
#define MONTH  5
#define YEAR   6

extern void i2c_get_time(void);
extern unsigned char time_buffer[];
extern const char month_array[18][3];
extern const struct messages msg1, msg2, msg3,msg15;
extern const char *month_name[12];
extern const char day_array[7][3];

extern void SetChrMode(void);
extern void SetCmdMode(void);
extern void lcd_init(void);
extern void domsg(const struct messages *);
extern void lcd_wr_data(unsigned char);
extern void lcd_wr_instr(unsigned char);
extern void lcd_text(char *);
extern void lcd_byte(char);
extern void lcd_wr_hex(unsigned int, unsigned char);
extern void convert_hex_bcd2(unsigned char, unsigned char *);
extern void lcd_wr_bcd(unsigned int, unsigned char);
extern void lcd_wr_bcd2(unsigned int, unsigned char);
extern void lcd_wr_bcd_A(unsigned int, unsigned char);
extern void lcd_wr_time(unsigned int, unsigned int);
extern void lcd_wr_hex16(unsigned int, unsigned int);
extern void lcd_wr_bcd4(unsigned int, unsigned int);
extern void clear_lcd(unsigned char);
//================================================================
#define SECTOR_MAX 16  // sectors per block
#define FLASH_TARGET_OFFSET (512 * 1024)  // start of my flash data
#define FLASH_SDATE_SECTOR 258     // 256 sectors for my log, 16 sectors per page
#define FLASH_SDATE_PAGE 4128     

void write_flash(unsigned char *, uint32_t);
void write_flash_sector(void);
void copy_ram_log_to_flash(struct log *ptr);
void erase_block(uint16_t);
void erase_all_blocks(void);
uint16_t is_sector_blank(uint32_t);
void read_flash_uart(uint32_t sector);
void read_sector(uint16_t sector, uint16_t number);
//void do_uart_RX(void);
void log4_data_uart(struct log *);
void write_log(struct log *);
void erase_all_sectors(void);
void log1_time_uart(void);
void show_log2(struct log *);

void read_page(uint16_t, uint16_t);
void find_first_blank_page(void);  // Find the first blank Page_Index (and Bock_index)
void myflash_erase_sector(uint16_t);
void erase_sector(uint16_t);
uint16_t is_page_blank(uint32_t);    
void dump_flash(uint32_t, uint32_t);
void dump_flash_page_hex(uint32_t); 
void write_page(uint32_t, unsigned char *);

uint32_t ints;  // for interrupt
unsigned int Entry_Read_Index, Flash_Write_Index, erase_flag, reset_rx_start;
uint16_t Page_Index, Last_Page, Sector_Index;
extern unsigned char uart_flag_RX, uart_char;
uint16_t first_time_flash;
//uint32_t page_end;

void test_read_sector(uint16_t);
void test_write_sector(uint16_t);
//================================================
void do_start_date(uint16_t);
void show_page(uint32_t);
void my_hextoa2(unsigned char, char *);
void dump_flash_page(uint32_t, uint16_t);  // with or without also dumping hex
void test10(void);
void copy_ram_log_to_flash(struct log *);
void log_flash_uart(uint32_t);
void show_log_ptr(struct log *);
void show_log_page(uint32_t);

void test_read_sector(uint16_t);
void myflash_erase_sector(uint16_t);
void erase_sector(uint16_t);
void erase_all_sectors(void);
void write_page(uint32_t, unsigned char *);

extern void temperature_itoa_str(int32_t, char *);      // remove leading zeros; end with NULL
extern void pressure_ltoa_str(uint32_t, char *);        // remove leading zeros; end with NULL
extern void humidity_btoa_str(uint8_t, char *);
//====================================================
